<?php
/*******************************************************************************/
//                          InstantCMS v1.9                                    //
//                      http://www.instantcms.ru/                              //
//                         plugin p_rand_avatar v1.0                          //
//                     written by Marat Fatikhov  aka                     //
//                     http://www.instantcms.ru/users/marat                    //
//                       E-mail: f-marat@mail.ru                               //
//                                                                             //
//                      LICENSED BY GNU/GPL v2                                 //
//                                                                             //
/********************************************************************************/

class p_rand_avatar extends cmsPlugin {

// ==================================================================== //

    public function __construct(){

        parent::__construct();
        
        //   

        $this->info['plugin']           = 'p_rand_avatar';
        $this->info['title']            = ' ';
        $this->info['description']      = '     ';
        $this->info['author']           = 'Marat Fatikhov';
        $this->info['version']          = '1.0';

        //  -
        $this->config['    ? 1 - ,  - ']   = 1;

        // ,    

        $this->events[]                 = 'USER_LOGOUT';
        
    }
    
// ==================================================================== //

    /**
     *   
     * @return bool
     */
    public function install(){

        return parent::install();

    }

// ==================================================================== //

    /**
     *   
     * @return bool
     */
    public function upgrade(){

        return parent::upgrade();

    }

// ==================================================================== //

    /**
     *  
     * @param string $event
     * @param mixed $item
     * @return mixed
     */
    public function execute($event, $item){

        parent::execute();
        
        switch ($event){

            case 'USER_LOGOUT': $this->addAvatar($item); break;

        }

    }

// ==================================================================== //

    private function addAvatar($item){

        $inCore = cmsCore::getInstance();
        $inDB   = cmsDatabase::getInstance();
        $inConf = cmsConfig::getInstance();

        $is_notify = $this->config['    ? 1 - ,  - '];

         if(!$item || !is_numeric($item)){ return;}
        //  
        $user = array();
        $user = $inDB->get_fields('cms_user_profiles', "`user_id` = '{$item}'", 'imageurl, gender, email_newmsg');

        //  , 
        if(!empty($user['imageurl'])){ return; }

        //     
        switch($user['gender']){

            case 'm':  $dir = PATH.'/images/users/avatars/rand_avatars_lib/male/'; break;
            case 'f':  $dir = PATH.'/images/users/avatars/rand_avatars_lib/female/'; break;
            default :  $dir = PATH.'/images/users/avatars/rand_avatars_lib/unisex/';

        }
        

        $files = array();
        $files = glob("$dir*.{jpg, jpeg, gif, bmp, png}", GLOB_BRACE);
        if(!($files)){ return; }

        srand();
        $key = array_rand($files);
        $filename = $files[$key];
        $realfile = $filename;
        $filename 		= md5($filename . '-' . $item . '-' . time()).'.jpg';

        // 
        $cfg = array();
        $cfg = $inCore->loadComponentConfig('users');
        if(!$cfg['component_enabled']) { return; }
        $inCore->includeGraphics();

        if (file_exists($realfile)){
           if (isset($cfg['smallw'])) { $smallw = $cfg['smallw']; } else { $smallw = 64; }
			     if (isset($cfg['medw'])) { 	 $medw = $cfg['medw']; } else { $medw = 200; }

			     $uploaddir 		= PATH.'/images/users/avatars/';
			     $uploadavatar 	= $uploaddir . $filename;
			     $uploadthumb 	= $uploaddir . 'small/' . $filename;
			  
           copy($realfile, $uploadavatar);
			     @img_resize($realfile, $uploadthumb, $smallw, $smallw);
			     //  
			     $sql = "UPDATE cms_user_profiles
					   SET imageurl = '$filename'
					   WHERE user_id = '$item'
					   LIMIT 1";
			     $inDB->query($sql);
			     //   , 
			     if($is_notify){
              cmsUser::sendMessage(-1, $item, "   ,       
              .       ,      <a href=\"".HOST."/users/{$item}/avatar.html\"> </a>");
              //  ,   e-mail
               if($user['email_newmsg']){
                  $user['email'] = $inDB->get_field('cms_users', "`id` = '{$item}'", 'email');
                  $letter_path    = PATH.'/includes/letters/newmessage.txt';
                  $letter         = file_get_contents($letter_path);
                  $letter = str_replace('{sitename}', $inConf->sitename, $letter);
                  $letter = str_replace('{from}', '  ', $letter);
                  $letter = str_replace('{date}', date('d-m-Y H:i:s'), $letter);
                  $letter = str_replace('{answerlink}', HOST.'/users/'.$item.'/messages.html', $letter);
                  $inCore->mailText($user['email'], ' ! - '.$inConf->sitename, $letter);
              }
          }
        }
    }
    
//==============================================================================//


} //class
?>
